## libcitygml 2.0.8

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0 FATAL_ERROR)

PROJECT ( libcitygml )

set(META_VERSION_MAJOR       "2")
set(META_VERSION_MINOR       "0")
set(META_VERSION_PATCH       "8")

set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")

SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules" )

IF(WIN32)

    IF(MSVC)
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

        # More MSVC specific compilation flags
        ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    ENDIF(MSVC)

    # Both Cygwin and Msys need -DNOMINMAX ???
    IF(UNIX)
        ADD_DEFINITIONS(-DNOMINMAX)
    ENDIF(UNIX)

########################################################################################################
# the foolowing options are MSVC specific,
# the first OSG_MSVC_VERSIONED_DLL activate a custom build-time layout that should allow to run examples and application
# fron bin folder without requiring installation step.
# it also prepend "osg${OPENSCENEGRAPH_SOVERSION}-" to only .dll files, leaving .lib files untouched in lib
# it also use a hack to get rid of Debug and Release folder in MSVC projects
# all the .dll and .pdb are in bin and all the .lib and .exp are in lib
#
# the second option disable incremental linking in debug build , that is enabled by default by CMake
##########################################################################################################

    IF(MSVC)
        # IF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
            # MESSAGE("Warning:  disabling versioned options 2.4.6 exibits inconsintencies in .pdb naming, at least under MSVC, suggested upgrading at least to 2.4.7")
            # SET(OSG_MSVC_VERSIONED_DLL OFF)
            # SET(OSG_MSVC_DEBUG_INCREMENTAL_LINK ON)
        # ELSE(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
            OPTION(LIBCITYGML_MSVC_VERSIONED_DLL "Set to ON to build libcitygml with versioned dll names" ON)
            MARK_AS_ADVANCED(LIBCITYGML_MSVC_VERSIONED_DLL)
            OPTION(LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK "Set to OFF to build libcitygml without incremental linking in debug (release is off by default)" ON)
            MARK_AS_ADVANCED(LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
            IF(NOT LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
                SET(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
                SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
                SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
            ENDIF(NOT LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
        # ENDIF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
    ENDIF(MSVC)
ENDIF(WIN32)

if(UNIX)
    if(APPLE)
        MESSAGE(STATUS "APPLE")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")
    else(APPLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")

        MESSAGE(STATUS "Setting UNIX compile flags: ${CMAKE_CXX_FLAGS}")
    endif(APPLE)
endif(UNIX)

IF(MSVC_IDE)
  # From CMake 2.8.2, new way to manage output generation dirs !
    # SET_TARGET_PROPERTIES(${LIB_NAME} PROPERTIES PREFIX "../")
    SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/bin)
    SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/bin)

    SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/lib)
    SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/lib)

    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/bin)
    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/bin)
ENDIF(MSVC_IDE)

SET(OUTPUT_BINDIR ${PROJECT_BINARY_DIR}/bin)
MAKE_DIRECTORY(${OUTPUT_BINDIR})
SET(EXECUTABLE_OUTPUT_PATH ${OUTPUT_BINDIR})

SET(OUTPUT_LIBDIR ${PROJECT_BINARY_DIR}/lib)
MAKE_DIRECTORY(${OUTPUT_LIBDIR})
SET(LIBRARY_OUTPUT_PATH ${OUTPUT_LIBDIR})

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
endif(NOT DEFINED BIN_INSTALL_DIR)
if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
endif(NOT DEFINED LIB_INSTALL_DIR)
if(NOT DEFINED DATA_INSTALL_DIR)
    set(DATA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share")
endif(NOT DEFINED DATA_INSTALL_DIR)
if(NOT DEFINED INCLUDE_INSTALL_DIR)
    set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/citygml")
endif(NOT DEFINED INCLUDE_INSTALL_DIR)
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR "${DATA_INSTALL_DIR}/man")
endif(NOT DEFINED MAN_INSTALL_DIR)
if(NOT DEFINED RESOURCE_INSTALL_DIR)
    set(RESOURCE_INSTALL_DIR "${DATA_INSTALL_DIR}/libcitygml${META_VERSION_MAJOR}/resource/")
endif(NOT DEFINED RESOURCE_INSTALL_DIR)
if(NOT DEFINED LOCALE_INSTALL_DIR)
    set(LOCALE_INSTALL_DIR "${DATA_INSTALL_DIR}/locale/")
endif(NOT DEFINED LOCALE_INSTALL_DIR)

# IF( DEBUG_BUILD )
  # SET( CMAKE_BUILD_TYPE "Debug" )
# ELSE( DEBUG_BUILD )
  # SET( CMAKE_BUILD_TYPE "Release" )
# ENDIF( DEBUG_BUILD )

IF( COMMAND cmake_policy )
  cmake_policy( SET CMP0003 NEW )
ENDIF( COMMAND cmake_policy )

IF(MSVC)
    OPTION(LIBCITYGML_STATIC_CRT "Set to ON to link libcitygml with the multithread CRT static library (instead of DLL)." ON)
ENDIF(MSVC)

IF( MSVC AND LIBCITYGML_STATIC_CRT )
  #We statically link to reduce dependancies
  FOREACH( flag_var CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO )
    IF( ${flag_var} MATCHES "/MD" )
      string( REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MD" )
    IF( ${flag_var} MATCHES "/MDd" )
      string( REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MDd" )
  ENDFOREACH( flag_var )
ENDIF( MSVC AND LIBCITYGML_STATIC_CRT )

# core
ADD_SUBDIRECTORY( sources )

# osg plugin
OPTION(LIBCITYGML_OSGPLUGIN "Set to ON to build libcitygml osgplugin programs." OFF)
IF   (LIBCITYGML_OSGPLUGIN)
  ADD_SUBDIRECTORY( osgplugin )
ENDIF(LIBCITYGML_OSGPLUGIN)

# test
OPTION(LIBCITYGML_TESTS "Set to ON to build libcitygml tests programs." ON)
IF   (LIBCITYGML_TESTS)
  ADD_SUBDIRECTORY( test )
ENDIF(LIBCITYGML_TESTS)


#-----------------------------------------------------------------------------
### uninstall target
#-----------------------------------------------------------------------------
OPTION(LIBCITYGML_UNINSTALL "Set to ON to generate libcitygml uninstall project." OFF)
IF (LIBCITYGML_UNINSTALL)
  CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
  ADD_CUSTOM_TARGET(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
ENDIF(LIBCITYGML_UNINSTALL)

#-----------------------------------------------------------------------------
### Create debian package if linux
#-----------------------------------------------------------------------------
IF(UNIX AND NOT APPLE)
  option(BUILD_DEBIAN_PACKAGE  "Creates a debian package" ON)
  if(BUILD_DEBIAN_PACKAGE)
      # set project description for packaging
      set(META_PROJECT_NAME        "libcitygml")
      set(META_PROJECT_SUMMARY     "Open source C++ library for parsing CityGML files")
      set(META_PROJECT_DESCRIPTION "libcitygml is a small and easy to use open source C++ library for parsing
                                    CityGML files in such a way that data can be easily exploited by 3D
                                    rendering applications (geometry data are tesselated and optimized for
                                    rendering during parsing). For instance, it can be used to develop readers
                                    of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
                                    Most metadata are not lost, they are available through a per-node hashmap.

                                    CityGML (City Geography Markup Language) is an XML-based schema for the
                                    modelling and exchange of georeferenced 3D city and landscape models that
                                    is quickly being adopted on an international level.")
      set(META_AUTHOR_ORGANIZATION "3D Content Logistics")
      set(META_AUTHOR_DOMAIN       "https://github.com/jklimke/libcitygml.git")
      set(META_AUTHOR_MAINTAINER   "Marcel Pursche <marcel.pursche@3dcontentlogistics.com>")

      # Package information
      string(TOLOWER ${META_PROJECT_NAME} package_name)          # Package name
      set(CPACK_PACKAGE_NAME                  "${META_PROJECT_NAME}")
      set(CPACK_PACKAGE_VENDOR                "${META_AUTHOR_ORGANIZATION}")
      set(CPACK_PACKAGE_DESCRIPTION_SUMMARY   "${META_PROJECT_SUMMARY}")
      set(CPACK_PACKAGE_DESCRIPTION           "${META_PROJECT_DESCRIPTION}")
      set(CPACK_PACKAGE_VERSION               "${META_VERSION}")
      set(CPACK_PACKAGE_VERSION_MAJOR         "${META_VERSION_MAJOR}")
      set(CPACK_PACKAGE_VERSION_MINOR         "${META_VERSION_MINOR}")
      set(CPACK_PACKAGE_VERSION_PATCH         "${META_VERSION_PATCH}")
      set(CPACK_RESOURCE_FILE_LICENSE         "${CMAKE_SOURCE_DIR}/LICENSE")
      set(CPACK_PACKAGE_RELOCATABLE           OFF)

      # Debian package information
      set(CPACK_DEBIAN_PACKAGE_NAME           "${package_name}")
      set(CPACK_DEBIAN_PACKAGE_VERSION        "${CPACK_PACKAGE_VERSION}")
      set(CPACK_DEBIAN_PACKAGE_MAINTAINER     "${META_AUTHOR_MAINTAINER}")
      set(CPACK_DEBIAN_PACKAGE_DESCRIPTION    "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}")
      set(CPACK_DEBIAN_PACKAGE_SECTION        "Development")
      set(CPACK_DEBIAN_PACKAGE_PRIORITY       "optional")
      set(CPACK_DEBIAN_PACKAGE_DEPENDS        "libgdal1h (>= 1.10.1), libxerces-c3.1 (>= 3.1.1-5)")
      set(CPACK_DEBIAN_PACKAGE_CONFLICTS      "libcitygml0, libcitygml0-dev")
      set(CPACK_DEBIAN_PACKAGE_HOMEPAGE       "${META_AUTHOR_DOMAIN}")
      set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA  "${CMAKE_CURRENT_SOURCE_DIR}/debian_scripts/postinst;")

      set(CPACK_GENERATOR "DEB")

      include(CPack)
  endif()
ENDIF()

=== osgplugin/CMakeLists.txt ===
set(target osgdb_citygml)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ON)
find_package( OpenSceneGraph REQUIRED osgDB osgViewer osgGA osgUtil osgText)

include_directories(
  ${OPENSCENEGRAPH_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/sources/include
)

set( sources ReaderWriterCityGML.cpp )

add_library(${target} SHARED ${sources})
set_target_properties(${target} PROPERTIES PREFIX "")
if(APPLE)
    SET(CMAKE_SHARED_LIBRARY_SUFFIX ".so")
endif(APPLE)
target_link_libraries(${target} ${OPENSCENEGRAPH_LIBRARIES} citygml)

set(OSG_PLUGINS "osgPlugins-${OPENSCENEGRAPH_VERSION}")
set(LIBCITYGML_OSG_PLUGIN_INSTALL_DIR "" CACHE PATH "The directory in which the plugin will be installed. (osgPlugins-<version> is appended to this path)")

set(PLUGIN_INSTALL_PATH lib/${OSG_PLUGINS})
if (LIBCITYGML_OSG_PLUGIN_INSTALL_DIR)
  set(PLUGIN_INSTALL_PATH ${LIBCITYGML_OSG_PLUGIN_INSTALL_DIR}/${OSG_PLUGINS})
endif()

add_definitions(-DPLUGIN_BIN_DIR=\"${CMAKE_BINARY_DIR}/lib\")
add_executable(citygmlOsgViewer CitygmlOsgViewer.cpp)
target_link_libraries(citygmlOsgViewer ${OPENSCENEGRAPH_LIBRARIES} citygml)

INSTALL(
    TARGETS ${target}
    RUNTIME DESTINATION ${PLUGIN_INSTALL_PATH}
    LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH}
    ARCHIVE DESTINATION ${PLUGIN_INSTALL_PATH}
)

INSTALL(
    TARGETS citygmlOsgViewer
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH}
    ARCHIVE DESTINATION ${PLUGIN_INSTALL_PATH}
)

=== sources/CMakeLists.txt ===
include(GenerateExportHeader)

IF (NOT DEFINED CMAKE_MODULE_PATH)
  GET_FILENAME_COMPONENT(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../CMakeModules" ABSOLUTE)
ENDIF (NOT DEFINED CMAKE_MODULE_PATH)

SET( target citygml )

FIND_PACKAGE( OpenGL REQUIRED )
FIND_PACKAGE( Xerces REQUIRED )

# gdal library
OPTION(LIBCITYGML_USE_GDAL "Set to ON to build libcitygml with GDAL library so that it supports coordinates transformations." ON)

IF( LIBCITYGML_USE_GDAL )
  FIND_PACKAGE( GDAL REQUIRED )
  ADD_DEFINITIONS( -DUSE_GDAL )
ELSE( LIBCITYGML_USE_GDAL )
  SET( GDAL_INCLUDE_DIR "" )
  SET( GDAL_LIBRARY "" )
ENDIF( LIBCITYGML_USE_GDAL )

OPTION(LIBCITYGML_DEBUG_POSTFIX "Set to on to add \"d\" postfix to targets" ON)
IF( LIBCITYGML_DEBUG_POSTFIX )
  SET(CMAKE_DEBUG_POSTFIX  "d")
ELSE( LIBCITYGML_DEBUG_POSTFIX )
  UNSET(CMAKE_DEBUG_POSTFIX)
ENDIF( LIBCITYGML_DEBUG_POSTFIX )

# Dynamic vs Static Linking
OPTION(LIBCITYGML_DYNAMIC "Set to ON to build libcitygml for dynamic linking.  Use OFF for static." ON)
IF   (LIBCITYGML_DYNAMIC)
  SET(LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC "SHARED")
  ADD_DEFINITIONS( -DLIBCITYGML_DYNAMIC )
ELSE (LIBCITYGML_DYNAMIC)
  SET(LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC "STATIC")
  ADD_DEFINITIONS( -DLIBCITYGML_STATIC )
ENDIF(LIBCITYGML_DYNAMIC)

ADD_DEFINITIONS( -DCITYGML_LIBRARY )

ADD_DEFINITIONS( -DLIBCITYGML_BUILD )

configure_file("${CMAKE_MODULE_PATH}/citygml_api.h.in" ${CMAKE_CURRENT_SOURCE_DIR}/include/citygml/citygml_api.h)

SET(EXPORT_HEADER_FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/include/citygml/citygml_export.h)

INCLUDE_DIRECTORIES(    ${CMAKE_CURRENT_SOURCE_DIR}/include
                        ${XERCESC_INCLUDE}
                        ${GLU_INCLUDE_PATH}
                        ${GDAL_INCLUDE_DIR})

SET(SOURCES
  src/citygml/attributesmap.cpp
  src/citygml/citymodel.cpp
  src/citygml/tesselator.cpp
  src/citygml/object.cpp
  src/citygml/featureobject.cpp
  src/citygml/appearance.cpp
  src/citygml/texture.cpp
  src/citygml/material.cpp
  src/citygml/georeferencedtexture.cpp
  src/citygml/envelope.cpp
  src/citygml/appearancemanager.cpp
  src/citygml/cityobject.cpp
  src/citygml/geometry.cpp
  src/citygml/implictgeometry.cpp
  src/citygml/linearring.cpp
  src/citygml/polygon.cpp
  src/citygml/transformmatrix.cpp
  src/citygml/texturetargetdefinition.cpp
  src/citygml/materialtargetdefinition.cpp
  src/citygml/texturecoordinates.cpp
  src/citygml/appearancetarget.cpp
  src/citygml/citygmlfactory.cpp
  src/citygml/polygonmanager.cpp
  src/citygml/geometrymanager.cpp
  src/citygml/linestring.cpp
  src/citygml/address.cpp

  src/parser/nodetypes.cpp
  src/parser/attributes.cpp

  src/parser/geocoordinatetransformer.cpp

  src/parser/citygmldocumentparser.cpp
  src/parser/parserxercesc.cpp
  src/parser/citygmlelementparser.cpp
  src/parser/elementparser.cpp

  src/parser/delayedchoiceelementparser.cpp
  src/parser/skipelementparser.cpp
  src/parser/sequenceparser.cpp

  src/parser/gmlobjectparser.cpp
  src/parser/gmlfeaturecollectionparser.cpp

  src/parser/citymodelelementparser.cpp
  src/parser/cityobjectelementparser.cpp
  src/parser/appearanceelementparser.cpp
  src/parser/materialelementparser.cpp
  src/parser/textureelementparser.cpp
  src/parser/georeferencedtextureelementparser.cpp
  src/parser/geometryelementparser.cpp
  src/parser/polygonelementparser.cpp
  src/parser/linestringelementparser.cpp
  src/parser/linearringelementparser.cpp
  src/parser/implicitgeometryelementparser.cpp
  src/parser/addressparser.cpp
)
if(UNIX)
  if (APPLE)
    set_source_files_properties(src/citygml/tesselator.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations") # for warnings: 'glu*' is deprecated...
  endif (APPLE)
endif(UNIX)

SET(PUBLIC_HEADER
  include/citygml/citygml_api.h
  include/citygml/citygml_export.h
  include/citygml/attributesmap.h
  include/citygml/enum_type_bitmask.h
  include/citygml/citygmllogger.h
  include/citygml/polygon.h
  include/citygml/material.h
  include/citygml/geometry.h
  include/citygml/object.h
  include/citygml/featureobject.h
  include/citygml/georeferencedtexture.h
  include/citygml/cityobject.h
  include/citygml/envelope.h
  include/citygml/appearance.h
  include/citygml/vecs.hpp
  include/citygml/citymodel.h
  include/citygml/linearring.h
  include/citygml/citygml.h
  include/citygml/transformmatrix.h
  include/citygml/implictgeometry.h
  include/citygml/tesselator.h
  include/citygml/texture.h
  include/citygml/appearancetargetdefinition.h
  include/citygml/texturetargetdefinition.h
  include/citygml/materialtargetdefinition.h
  include/citygml/texturecoordinates.h
  include/citygml/appearancetarget.h
  include/citygml/citygmlfactory.h
  include/citygml/linestring.h
  include/citygml/address.h
)

SET(HEADERS
  ${PUBLIC_HEADER}

  ${CMAKE_MODULE_PATH}/citygml_api.h.in

  include/citygml/tesselator.h
  include/citygml/utils.h
  include/citygml/appearancemanager.h
  include/citygml/polygonmanager.h
  include/citygml/geometrymanager.h

  include/parser/nodetypes.h
  include/parser/attributes.h
  include/parser/documentlocation.h

  include/parser/parserutils.hpp
  include/parser/geocoordinatetransformer.h

  include/parser/citygmldocumentparser.h
  include/parser/citygmlelementparser.h
  include/parser/elementparser.h

  include/parser/delayedchoiceelementparser.h
  include/parser/skipelementparser.h
  include/parser/sequenceparser.h

  include/parser/gmlobjectparser.h
  include/parser/gmlfeaturecollectionparser.h

  include/parser/citymodelelementparser.h
  include/parser/cityobjectelementparser.h
  include/parser/appearanceelementparser.h
  include/parser/materialelementparser.h
  include/parser/textureelementparser.h
  include/parser/georeferencedtextureelementparser.h
  include/parser/geometryelementparser.h
  include/parser/polygonelementparser.h
  include/parser/linestringelementparser.h
  include/parser/linearringelementparser.h
  include/parser/implicitgeometryelementparser.h
  include/parser/addressparser.h
)

ADD_LIBRARY( ${target} ${LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC} ${SOURCES} ${HEADERS} )


generate_export_header(citygml
                       EXPORT_MACRO_NAME LIBCITYGML_EXPORT
                       EXPORT_FILE_NAME ${EXPORT_HEADER_FILE_NAME})

TARGET_LINK_LIBRARIES( ${target} ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} ${GDAL_LIBRARY} )

set_target_properties( ${target} PROPERTIES
    VERSION ${META_VERSION}
    SOVERSION ${META_VERSION_MAJOR}
)

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
endif(NOT DEFINED BIN_INSTALL_DIR)
if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
endif(NOT DEFINED LIB_INSTALL_DIR)
if(NOT DEFINED INCLUDE_INSTALL_DIR)
    set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/citygml")
endif(NOT DEFINED INCLUDE_INSTALL_DIR)

INSTALL(
    TARGETS ${target}
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)


# FIXME: Do not run for OS X framework
INSTALL(
    FILES
      ${PUBLIC_HEADER}
    DESTINATION  ${INCLUDE_INSTALL_DIR}
)

INSTALL(
    FILES
      ${EXPORT_HEADER_FILE_NAME}
    DESTINATION
      ${INCLUDE_INSTALL_DIR}
)


configure_file(citygml.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== test/CMakeLists.txt ===
IF(WIN32)
    SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
ENDIF()

FIND_PACKAGE( OpenGL REQUIRED )
FIND_PACKAGE( Xerces REQUIRED )

IF( LIBCITYGML_DYNAMIC )
  ADD_DEFINITIONS( -DLIBCITYGML_DYNAMIC )
ELSE( LIBCITYGML_DYNAMIC )
  ADD_DEFINITIONS( -DLIBCITYGML_STATIC )
ENDIF( LIBCITYGML_DYNAMIC )

# INCLUDE_DIRECTORIES( ${CITYGML_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include ${CMAKE_BINARY_DIR}/sources/include)

SET( PRG_SRCS citygmltest.cpp )

ADD_EXECUTABLE( citygmltest ${PRG_SRCS} )

TARGET_LINK_LIBRARIES( citygmltest citygml ${XERCESC_LIBRARY} ${OPENGL_LIBRARIES} )

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
endif(NOT DEFINED BIN_INSTALL_DIR)

install(TARGETS citygmltest RUNTIME DESTINATION ${BIN_INSTALL_DIR})

=== debian/changelog ===
libcitygml (2.0.8-1) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.1.3, no changes.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 10 Jan 2018 15:54:00 +0100

libcitygml (2.0.8-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.1.2, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 19 Dec 2017 23:47:54 +0100

libcitygml (2.0.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop patches applied/included upstream.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 16 Nov 2017 19:49:37 +0100

libcitygml (2.0.4-2) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.1.1, no changes.
  * Strip trailing whitespace from changelog.
  * Add patch by Matthias Klose to fix FTBFS with xerces-3.2.
    (closes: #881924)
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 16 Nov 2017 17:10:50 +0100

=== debian/control ===
Source: libcitygml
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: YunQiang Su <wzssyqa@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libxml2-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu-dev,
               pkg-kde-tools
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/libcitygml.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/libcitygml.git
Homepage: https://github.com/jklimke/libcitygml

Package: libcitygml2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open source C++ library for parsing CityGML files
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains share library.

Package: libcitygml-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcitygml2 (= ${binary:Version}),
         ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Breaks: libcitygml0-dev (<< 1.4.3-1~)
Replaces: libcitygml0-dev (<< 1.4.3-1~)
Description: Static and header files of libcitygml
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains develop files: static and header files of libcitygml.

Package: libcitygml-bin
Architecture: any
Section: utils
Depends: libcitygml2 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libcitygml0-bin (<< 1.4.3-1~)
Replaces: libcitygml0-bin (<< 1.4.3-1~)
Description: Utils of libcitygml - citygmltest
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains the citygmltest utility.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

CITYGML_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_clean:
	dh_auto_clean
	-rm -rf obj-*-*

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(CITYGML_VERSION)

## libcitygml 2.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,11 @@
 
 set(META_VERSION_MAJOR       "2")
 set(META_VERSION_MINOR       "0")
-set(META_VERSION_PATCH       "8")
+set(META_VERSION_PATCH       "9")
 
 set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")
 
-SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules" )
+SET( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules" )
 
 IF(WIN32)
 
@@ -197,7 +197,7 @@
       set(CPACK_PACKAGE_VERSION_MAJOR         "${META_VERSION_MAJOR}")
       set(CPACK_PACKAGE_VERSION_MINOR         "${META_VERSION_MINOR}")
       set(CPACK_PACKAGE_VERSION_PATCH         "${META_VERSION_PATCH}")
-      set(CPACK_RESOURCE_FILE_LICENSE         "${CMAKE_SOURCE_DIR}/LICENSE")
+      set(CPACK_RESOURCE_FILE_LICENSE         "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
       set(CPACK_PACKAGE_RELOCATABLE           OFF)
 
       # Debian package information

=== osgplugin/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 include_directories(
   ${OPENSCENEGRAPH_INCLUDE_DIRS}
-  ${CMAKE_SOURCE_DIR}/sources/include
+  ${CMAKE_CURRENT_SOURCE_DIR}/../sources/include
 )
 
 set( sources ReaderWriterCityGML.cpp )

=== sources/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 include(GenerateExportHeader)
 
 IF (NOT DEFINED CMAKE_MODULE_PATH)
-  GET_FILENAME_COMPONENT(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../CMakeModules" ABSOLUTE)
+  GET_FILENAME_COMPONENT(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../CMakeModules" ABSOLUTE)
 ENDIF (NOT DEFINED CMAKE_MODULE_PATH)
 
 SET( target citygml )

=== debian/changelog ===
libcitygml (2.0.9-3build3) jammy; urgency=medium

  * No-change rebuild against libgdal30

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 09 Dec 2021 00:27:49 +0000

libcitygml (2.0.9-3build2) jammy; urgency=medium

  * No-change rebuild against libgdal29

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Oct 2021 14:18:40 +0000

libcitygml (2.0.9-3build1) hirsute; urgency=medium

  * No-change rebuild for gdal soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Dec 2020 09:41:22 +0100

libcitygml (2.0.9-3) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.5.0, no changes.
  * Update watch file to limit matches to archive path.
  * Add Build-Depends-Package field to symbols file.
  * Add lintian overrides for file-references-package-build-path.
  * Update gbp.conf to use --source-only-changes by default.
  * Update symbols for amd64.
  * Drop Name field from upstream metadata.
  * Bump debhelper compat to 10.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 01 Nov 2020 20:04:20 +0100

libcitygml (2.0.9-2) unstable; urgency=medium

  * Team upload.
  * Strip trailing whitespace from control & rules files.
  * Bump Standards-Version to 4.1.5, no changes.
  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 31 Jul 2018 19:40:36 +0200

libcitygml (2.0.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright-format URL to use HTTPS.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.4, no changes.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Apr 2018 16:44:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: libcitygml
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: YunQiang Su <wzssyqa@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10~),
                cmake,
                libxml2-dev,
                libgdal-dev,
                libgl1-mesa-dev | libgl-dev,
                libglu-dev,
                pkg-kde-tools
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/libcitygml.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/libcitygml.git
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/debian-gis-team/libcitygml
+Vcs-Git: https://salsa.debian.org/debian-gis-team/libcitygml.git
 Homepage: https://github.com/jklimke/libcitygml
 
 Package: libcitygml2
@@ -79,4 +80,3 @@
  is quickly being adopted on an international level.
  .
  This package contains the citygmltest utility.
-

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g,\
filenamemangle=s/(?:.*)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/libcitygml-$1.$2/ \
https://github.com/jklimke/libcitygml/releases \
(?:.*?/archive/)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## libcitygml 2.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,8 @@
 PROJECT ( libcitygml )
 
 set(META_VERSION_MAJOR       "2")
-set(META_VERSION_MINOR       "0")
-set(META_VERSION_PATCH       "9")
+set(META_VERSION_MINOR       "4")
+set(META_VERSION_PATCH       "1")
 
 set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")

=== sources/CMakeLists.txt ===
--- 
+++ 
@@ -77,6 +77,8 @@
   src/citygml/geometrymanager.cpp
   src/citygml/linestring.cpp
   src/citygml/address.cpp
+  src/citygml/rectifiedgridcoverage.cpp
+  src/citygml/externalreference.cpp
 
   src/parser/nodetypes.cpp
   src/parser/attributes.cpp
@@ -98,11 +100,13 @@
   src/parser/citymodelelementparser.cpp
   src/parser/cityobjectelementparser.cpp
   src/parser/appearanceelementparser.cpp
+  src/parser/externalreferenceparser.cpp
   src/parser/materialelementparser.cpp
   src/parser/textureelementparser.cpp
   src/parser/georeferencedtextureelementparser.cpp
   src/parser/geometryelementparser.cpp
   src/parser/polygonelementparser.cpp
+  src/parser/rectifiedgridcoverageparser.cpp
   src/parser/linestringelementparser.cpp
   src/parser/linearringelementparser.cpp
   src/parser/implicitgeometryelementparser.cpp
@@ -145,6 +149,8 @@
   include/citygml/citygmlfactory.h
   include/citygml/linestring.h
   include/citygml/address.h
+  include/citygml/rectifiedgridcoverage.h
+  include/citygml/externalreference.h
 )
 
 SET(HEADERS
@@ -179,11 +185,13 @@
   include/parser/citymodelelementparser.h
   include/parser/cityobjectelementparser.h
   include/parser/appearanceelementparser.h
+  include/parser/externalreferenceparser.h
   include/parser/materialelementparser.h
   include/parser/textureelementparser.h
   include/parser/georeferencedtextureelementparser.h
   include/parser/geometryelementparser.h
   include/parser/polygonelementparser.h
+  include/parser/rectifiedgridcoverageparser.h
   include/parser/linestringelementparser.h
   include/parser/linearringelementparser.h
   include/parser/implicitgeometryelementparser.h
@@ -197,7 +205,10 @@
                        EXPORT_MACRO_NAME LIBCITYGML_EXPORT
                        EXPORT_FILE_NAME ${EXPORT_HEADER_FILE_NAME})
 
-TARGET_LINK_LIBRARIES( ${target} ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} ${GDAL_LIBRARY} )
+TARGET_LINK_LIBRARIES( ${target} PUBLIC ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} )
+if(LIBCITYGML_USE_GDAL)
+    TARGET_LINK_LIBRARIES( ${target} PUBLIC ${GDAL_LIBRARY} )
+endif(LIBCITYGML_USE_GDAL)
 
 set_target_properties( ${target} PROPERTIES
     VERSION ${META_VERSION}
@@ -214,19 +225,49 @@
     set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/citygml")
 endif(NOT DEFINED INCLUDE_INSTALL_DIR)
 
+if(WIN32)
+  set(CONFIG_INSTALL_DIR "cmake")
+else()
+  set(CONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/citygml")
+endif()
+
 INSTALL(
     TARGETS ${target}
+    EXPORT citygmlConfigInternal
     RUNTIME DESTINATION ${BIN_INSTALL_DIR}
     LIBRARY DESTINATION ${LIB_INSTALL_DIR}
     ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
-)
-
+    COMPONENT "runtime"
+)
+INSTALL(
+    EXPORT citygmlConfigInternal
+    DESTINATION "${CONFIG_INSTALL_DIR}"
+    NAMESPACE "citygml::"
+    COMPONENT "development"
+)
+
+include(CMakePackageConfigHelpers)
+configure_package_config_file(
+  "${CMAKE_CURRENT_SOURCE_DIR}/citygmlConfig.cmake.in"
+  "${CMAKE_CURRENT_BINARY_DIR}/citygmlConfig.cmake"
+  INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}")
+write_basic_package_version_file(
+  ${CMAKE_CURRENT_BINARY_DIR}/citygmlConfigVersion.cmake
+  VERSION "${META_VERSION}"
+  COMPATIBILITY SameMajorVersion)
+INSTALL(
+    FILES ${CMAKE_CURRENT_BINARY_DIR}/citygmlConfig.cmake
+          ${CMAKE_CURRENT_BINARY_DIR}/citygmlConfigVersion.cmake
+    DESTINATION "${CONFIG_INSTALL_DIR}"
+    COMPONENT "development"
+)
 
 # FIXME: Do not run for OS X framework
 INSTALL(
     FILES
       ${PUBLIC_HEADER}
     DESTINATION  ${INCLUDE_INSTALL_DIR}
+    COMPONENT "development"
 )
 
 INSTALL(
@@ -234,10 +275,26 @@
       ${EXPORT_HEADER_FILE_NAME}
     DESTINATION
       ${INCLUDE_INSTALL_DIR}
-)
-
+    COMPONENT "development"
+)
+
+if (LIBCITYGML_DEBUG_POSTFIX AND CMAKE_BUILD_TYPE STREQUAL "Debug")
+    set(LIBCITYGML_POSTFIX ${CMAKE_DEBUG_POSTFIX})
+else()
+    set(LIBCITYGML_POSTFIX "")
+endif()
+
+set(PKG_CONFIG_REQUIRES "xerces-c glu")
+
+if (LIBCITYGML_USE_GDAL)
+    set(PKG_CONFIG_REQUIRES "${PKG_CONFIG_REQUIRES} gdal")
+endif()
 
 configure_file(citygml.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc)
 
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
-
+INSTALL(
+    FILES ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc 
+    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
+    COMPONENT "development"
+)
+

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 ENDIF( LIBCITYGML_DYNAMIC )
 
 # INCLUDE_DIRECTORIES( ${CITYGML_INCLUDE_DIR} )
-INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include ${CMAKE_BINARY_DIR}/sources/include)
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../sources/include ${CMAKE_BINARY_DIR}/sources/include)
 
 SET( PRG_SRCS citygmltest.cpp )

=== debian/changelog ===
libcitygml (2.4.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.1, no changes.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 27 Jun 2022 15:18:15 +0200

libcitygml (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.
  * Update symbols for other architectures.
  * Include CMake files in -dev package.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Mar 2022 05:47:00 +0100

libcitygml (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump watch file version to 4.
  * Bump Standards-Version to 4.6.0, no changes.
  * Update watch file for GitHub URL changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Update lintian overrides.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 08 Mar 2022 16:20:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: libcitygml
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: YunQiang Su <wzssyqa@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libxml2-dev,
                libgdal-dev,
                libgl1-mesa-dev | libgl-dev,
                libglu-dev,
                pkg-kde-tools
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libcitygml
 Vcs-Git: https://salsa.debian.org/debian-gis-team/libcitygml.git
 Homepage: https://github.com/jklimke/libcitygml

=== debian/rules ===
--- 
+++ 
@@ -25,9 +25,5 @@
 	dh_auto_configure -- \
 		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 
-override_dh_install:
-	dh_install --list-missing
-
 override_dh_makeshlibs:
 	dh_makeshlibs -- -c0 -v$(CITYGML_VERSION)
-

## libcitygml 2.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -135,6 +135,9 @@
   ENDFOREACH( flag_var )
 ENDIF( MSVC AND LIBCITYGML_STATIC_CRT )
 
+
+OPTION(LIBCITYGML_USE_OPENGL "Set to OFF to prevent use of GL libraries. Tesselator won't be compiled." ON)
+
 # core
 ADD_SUBDIRECTORY( sources )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,9 @@
     SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
 ENDIF()
 
-FIND_PACKAGE( OpenGL REQUIRED )
+IF( LIBCITYGML_USE_OPENGL)
+  FIND_PACKAGE( OpenGL REQUIRED )
+ENDIF( LIBCITYGML_USE_OPENGL )
 FIND_PACKAGE( Xerces REQUIRED )
 
 IF( LIBCITYGML_DYNAMIC )
@@ -18,7 +20,11 @@
 
 ADD_EXECUTABLE( citygmltest ${PRG_SRCS} )
 
-TARGET_LINK_LIBRARIES( citygmltest citygml ${XERCESC_LIBRARY} ${OPENGL_LIBRARIES} )
+TARGET_LINK_LIBRARIES( citygmltest citygml ${XERCESC_LIBRARY})
+IF(LIBCITYGML_USE_OPENGL)
+  TARGET_COMPILE_DEFINITIONS( citygmltest PUBLIC LIBCITYGML_USE_OPENGL)
+  TARGET_LINK_LIBRARIES( citygmltest citygml ${OPENGL_LIBRARIES} )
+ENDIF(LIBCITYGML_USE_OPENGL)
 
 if(NOT DEFINED BIN_INSTALL_DIR)
     set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")

=== debian/changelog ===
libcitygml (2.5.1-1build1) mantic; urgency=medium

  * Rebuild against latest gdal

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 27 Jun 2023 13:51:25 -0400

libcitygml (2.5.1-1) unstable; urgency=medium

  * Team upload.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 13:12:30 +0200

libcitygml (2.5.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 11 May 2023 11:24:58 +0200

libcitygml (2.5.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Update symbols for amd64.
  * Drop obsolete libgl1-mesa-dev build dependency.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 14 Feb 2023 15:04:49 +0100

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,14 @@
                cmake,
                libxml2-dev,
                libgdal-dev,
-               libgl1-mesa-dev | libgl-dev,
+               libgl-dev,
                libglu-dev,
                pkg-kde-tools
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libcitygml
 Vcs-Git: https://salsa.debian.org/debian-gis-team/libcitygml.git
 Homepage: https://github.com/jklimke/libcitygml
+Rules-Requires-Root: no
 
 Package: libcitygml2
 Architecture: any

## libcitygml 2.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0 FATAL_ERROR)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.5.0 FATAL_ERROR)
 
 PROJECT ( libcitygml )
 
 set(META_VERSION_MAJOR       "2")
-set(META_VERSION_MINOR       "4")
-set(META_VERSION_PATCH       "1")
+set(META_VERSION_MINOR       "5")
+set(META_VERSION_PATCH       "2")
 
 set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")
 
@@ -150,6 +150,7 @@
 # test
 OPTION(LIBCITYGML_TESTS "Set to ON to build libcitygml tests programs." ON)
 IF   (LIBCITYGML_TESTS)
+  enable_testing()
   ADD_SUBDIRECTORY( test )
 ENDIF(LIBCITYGML_TESTS)
 
@@ -220,3 +221,5 @@
       include(CPack)
   endif()
 ENDIF()
+
+

=== sources/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,11 @@
 
 SET( target citygml )
 
-FIND_PACKAGE( OpenGL REQUIRED )
+IF( LIBCITYGML_USE_OPENGL)
+  FIND_PACKAGE( OpenGL REQUIRED )
+ELSE( LIBCITYGML_USE_OPENGL )
+  SET( GLU_INCLUDE_PATH "" )
+ENDIF( LIBCITYGML_USE_OPENGL )
 FIND_PACKAGE( Xerces REQUIRED )
 
 # gdal library
@@ -53,7 +57,7 @@
 SET(SOURCES
   src/citygml/attributesmap.cpp
   src/citygml/citymodel.cpp
-  src/citygml/tesselator.cpp
+  src/citygml/tesselatorbase.cpp
   src/citygml/object.cpp
   src/citygml/featureobject.cpp
   src/citygml/appearance.cpp
@@ -112,9 +116,12 @@
   src/parser/implicitgeometryelementparser.cpp
   src/parser/addressparser.cpp
 )
+
 if(UNIX)
   if (APPLE)
-    set_source_files_properties(src/citygml/tesselator.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations") # for warnings: 'glu*' is deprecated...
+    if (LIBCITYGML_USE_OPENGL)
+      set_source_files_properties(src/citygml/tesselator.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations") # for warnings: 'glu*' is deprecated...
+    endif (LIBCITYGML_USE_OPENGL)
   endif (APPLE)
 endif(UNIX)
 
@@ -139,7 +146,7 @@
   include/citygml/citygml.h
   include/citygml/transformmatrix.h
   include/citygml/implictgeometry.h
-  include/citygml/tesselator.h
+  include/citygml/tesselatorbase.h
   include/citygml/texture.h
   include/citygml/appearancetargetdefinition.h
   include/citygml/texturetargetdefinition.h
@@ -153,12 +160,24 @@
   include/citygml/externalreference.h
 )
 
+
+if(LIBCITYGML_USE_OPENGL) 
+  SET(SOURCES 
+    ${SOURCES} 
+    src/citygml/tesselator.cpp
+  )
+
+  SET(PUBLIC_HEADER 
+    ${PUBLIC_HEADER} 
+    include/citygml/tesselator.h
+  )
+endif(LIBCITYGML_USE_OPENGL)
+
 SET(HEADERS
   ${PUBLIC_HEADER}
 
   ${CMAKE_MODULE_PATH}/citygml_api.h.in
 
-  include/citygml/tesselator.h
   include/citygml/utils.h
   include/citygml/appearancemanager.h
   include/citygml/polygonmanager.h
@@ -205,7 +224,10 @@
                        EXPORT_MACRO_NAME LIBCITYGML_EXPORT
                        EXPORT_FILE_NAME ${EXPORT_HEADER_FILE_NAME})
 
-TARGET_LINK_LIBRARIES( ${target} PUBLIC ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} )
+TARGET_LINK_LIBRARIES( ${target} PUBLIC ${XERCESC_LIBRARIES} )
+if(LIBCITYGML_USE_OPENGL)
+  TARGET_LINK_LIBRARIES( ${target} PUBLIC ${OPENGL_LIBRARIES} )
+endif(LIBCITYGML_USE_OPENGL)
 if(LIBCITYGML_USE_GDAL)
     TARGET_LINK_LIBRARIES( ${target} PUBLIC ${GDAL_LIBRARY} )
 endif(LIBCITYGML_USE_GDAL)
@@ -284,7 +306,11 @@
     set(LIBCITYGML_POSTFIX "")
 endif()
 
-set(PKG_CONFIG_REQUIRES "xerces-c glu")
+set(PKG_CONFIG_REQUIRES "xerces-c")
+
+if(LIBCITYGML_USE_OPENGL)
+  set(PKG_CONFIG_REQUIRES "${PKG_CONFIG_REQUIRES} glu")
+  endif(LIBCITYGML_USE_OPENGL)
 
 if (LIBCITYGML_USE_GDAL)
     set(PKG_CONFIG_REQUIRES "${PKG_CONFIG_REQUIRES} gdal")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -31,3 +31,8 @@
 endif(NOT DEFINED BIN_INSTALL_DIR)
 
 install(TARGETS citygmltest RUNTIME DESTINATION ${BIN_INSTALL_DIR})
+
+
+add_test(NAME berlin_open_data_sample_data COMMAND citygmltest ../../data/berlin_open_data_sample_data.citygml)
+add_test(NAME b1_lod2_s COMMAND citygmltest ../../data/b1_lod2_s.gml)
+add_test(NAME FZK-Haus-LoD0-KIT-IAI-KHH-B36-V1 COMMAND citygmltest ../../data/FZK-Haus-LoD0-KIT-IAI-KHH-B36-V1.gml)

=== debian/changelog ===
libcitygml (2.5.2-1build6) resolute; urgency=medium

  * No-change rebuild for libgdal37.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Oct 2025 20:50:20 +0000

libcitygml (2.5.2-1build5) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 May 2025 05:50:34 +0200

libcitygml (2.5.2-1build4) plucky; urgency=medium

  * No-change rebuild for libgdal36.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 31 Dec 2024 23:52:30 +0000

libcitygml (2.5.2-1build3) oracular; urgency=medium

  * Rebuild against new libgdal35.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 May 2024 11:07:19 +0200

libcitygml (2.5.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:55:01 +0000

libcitygml (2.5.2-1build1) noble; urgency=medium

  * No-change rebuild against libxerces-c3.2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 17 Mar 2024 07:47:43 +0000

libcitygml (2.5.2-1) unstable; urgency=medium

  * Team upload.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 08 Jan 2024 13:41:44 +0100

libcitygml (2.5.2-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump debhelper compat to 13.
  * Remove generated files in clean target.
    (closes: #1047986)
  * Use execute_after instead of override in rules file.
  * Enable Salsa CI.
  * Switch to dh-sequence-*.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 05 Jan 2024 06:18:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: libcitygml
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: YunQiang Su <wzssyqa@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
+               dh-sequence-pkgkde-symbolshelper,
                cmake,
                libxml2-dev,
                libgdal-dev,

=== debian/rules ===
--- 
+++ 
@@ -15,10 +15,9 @@
 CITYGML_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
 
 %:
-	dh $@ --with pkgkde_symbolshelper
+	dh $@
 
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_auto_clean:
 	-rm -rf obj-*-*
 
 override_dh_auto_configure:

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g,\
filenamemangle=s/(?:.*)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/libcitygml-$1.$2/ \
https://github.com/jklimke/libcitygml/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
